<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/create_data_segment_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr"> 1 </span>03/05/85  create_data_segment_
<span id="L2" class="LineNr"> 2 </span>
<span id="L3" class="LineNr"> 3 </span>
<span id="L4" class="LineNr"> 4 </span>The create_data_segment_ subroutine is used in conjunction with the
<span id="L5" class="LineNr"> 5 </span>create_data_segment command to create a standard object segment from
<span id="L6" class="LineNr"> 6 </span>PL/I data structures passed to it as parameters.  The
<span id="L7" class="LineNr"> 7 </span>create_data_segment_ subroutine is called from a PL/I program that has
<span id="L8" class="LineNr"> 8 </span>defined in it either one or two specific PL/I structures, whose
<span id="L9" class="LineNr"> 9 </span>contents are to be placed in the text and/or static sections of the
<span id="L10" class="LineNr">10 </span>object segment to be created.  The level-2 structure component names
<span id="L11" class="LineNr">11 </span>become entry point names for the object segment, i.e., names that can
<span id="L12" class="LineNr">12 </span>be found by links so that other programs may reference the data by
<span id="L13" class="LineNr">13 </span>name.
<span id="L14" class="LineNr">14 </span>
<span id="L15" class="LineNr">15 </span>
<span id="L16" class="LineNr">16 </span>Entry points in create_data_segment_:
<span id="L17" class="LineNr">17 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L18" class="LineNr">18 </span>
<span id="L19" class="LineNr">19 </span>
<span id="L20" class="LineNr">20 </span>:Entry:  create_data_segment_:  03/05/85  create_data_segment_
<span id="L21" class="LineNr">21 </span>
<span id="L22" class="LineNr">22 </span>
<span id="L23" class="LineNr">23 </span>Function:
<span id="L24" class="LineNr">24 </span>is used in conjunction with the create_data_segment command to create
<span id="L25" class="LineNr">25 </span>a standard object segment from PL/I data structures passed to it as
<span id="L26" class="LineNr">26 </span>parameters.
<span id="L27" class="LineNr">27 </span>
<span id="L28" class="LineNr">28 </span>
<span id="L29" class="LineNr">29 </span>Syntax:
<span id="L30" class="LineNr">30 </span>declare create_data_segment_ entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L31" class="LineNr">31 </span>call create_data_segment_ <span class="textRainbow_lv0_p0">(</span>cds_arg_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L32" class="LineNr">32 </span>
<span id="L33" class="LineNr">33 </span>
<span id="L34" class="LineNr">34 </span>Arguments:
<span id="L35" class="LineNr">35 </span>cds_arg_ptr
<span id="L36" class="LineNr">36 </span>   is a pointer to a structure <span class="textRainbow_lv0_p0">(</span>see &quot;Structure&quot; below<span class="textRainbow_lv0_p0">)</span> containing
<span id="L37" class="LineNr">37 </span>   information to be passed to the create_data_segment_ subroutine,
<span id="L38" class="LineNr">38 </span>   specifying the structures to be used to create the object segment.
<span id="L39" class="LineNr">39 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L40" class="LineNr">40 </span>code
<span id="L41" class="LineNr">41 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> It can be
<span id="L42" class="LineNr">42 </span>   error_table_$translation_failed if no object segment is created.
<span id="L43" class="LineNr">43 </span>
<span id="L44" class="LineNr">44 </span>
<span id="L45" class="LineNr">45 </span>Notes:  The brief translator name placed in object segments produced by
<span id="L46" class="LineNr">46 </span>the create_data_segment_ subroutine is cds.
<span id="L47" class="LineNr">47 </span>
<span id="L48" class="LineNr">48 </span>If the defs_in_link switch is supplied as on <span class="textRainbow_lv0_p0">(</span>&quot;1&quot;b<span class="textRainbow_lv0_p0">)</span>, then a
<span id="L49" class="LineNr">49 </span>nonrelocatable, nonstandard object segment is produced.
<span id="L50" class="LineNr">50 </span>
<span id="L51" class="LineNr">51 </span>All text and static-resident information created is supplied with
<span id="L52" class="LineNr">52 </span>absolute relocation.  Hence, one must be wary of threads and pointers
<span id="L53" class="LineNr">53 </span>in one's structures, as they are not relocated if the object segment is
<span id="L54" class="LineNr">54 </span>bound.
<span id="L55" class="LineNr">55 </span>
<span id="L56" class="LineNr">56 </span>The program that calls the create_data_segment_ subroutine must be in
<span id="L57" class="LineNr">57 </span>the PL/I language.  It must be compiled with the -table control
<span id="L58" class="LineNr">58 </span>argument.  The create_data_segment command provides for this.
<span id="L59" class="LineNr">59 </span>
<span id="L60" class="LineNr">60 </span>
<span id="L61" class="LineNr">61 </span>It is essential that structures specified by cds_args.sections be at
<span id="L62" class="LineNr">62 </span>least referenced in the calling program, or they are not described in
<span id="L63" class="LineNr">63 </span>the runtime symbol table.
<span id="L64" class="LineNr">64 </span>
<span id="L65" class="LineNr">65 </span>The create_data_segment_ program, in its capacity as a translator,
<span id="L66" class="LineNr">66 </span>issues diagnostic messages on the terminal, as opposed to returning
<span id="L67" class="LineNr">67 </span>detailed status codes.
<span id="L68" class="LineNr">68 </span>
<span id="L69" class="LineNr">69 </span>All regions of the text and/or static sections not explicitly set by
<span id="L70" class="LineNr">70 </span>the calling program, whether via &quot;init&quot; attributes or explicit code,
<span id="L71" class="LineNr">71 </span>may not be assumed to contain zero or any other quantity.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
